import os

import requests

from bs4 import BeautifulSoup

from src.core.result import ResultTypeEnum, Result
from src.parsers.base_parser import BaseParser


class YappyParser(BaseParser):
    BASE_DIR = os.path.abspath(f"downloads/Yappy")

    def get_video_link(self):
        resp = requests.get(self.params["link"])
        resp.encoding = self.BASE_ENCODING
        soup = BeautifulSoup(resp.text, 'lxml')

        link = soup.find('video').get("src")
        title = soup.find('title').get_text()
        return link, title

    def video_download(self, link: str = None, title: str = None):
        if not link and not title:
            link, title = self.get_video_link()

        if os.path.exists(os.path.join(os.getcwd() + f"Yappy/{title}.mp4")):
            return Result(result_type=ResultTypeEnum.EXIST)

        video_response = requests.get(link)
        self.make_sure_path_exists()
        with open(self.BASE_DIR + f"/{title}.mp4", "wb") as output:
            output.write(video_response.content)
